Code

GIT 1.5.4.5
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.  You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example:       git-rebase master~1 topic
26         A---B---C topic                   A'\''--B'\''--C'\'' topic
27        /                   -->           /
28   D---E---F---G master          D---E---F---G master
29 '
31 SUBDIRECTORY_OK=Yes
32 OPTIONS_SPEC=
33 . git-sh-setup
34 set_reflog_action rebase
35 require_work_tree
36 cd_to_toplevel
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
42 "
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest=$GIT_DIR/.dotest-merge
47 prec=4
48 verbose=
49 git_am_opt=
51 continue_merge () {
52         test -n "$prev_head" || die "prev_head must be defined"
53         test -d "$dotest" || die "$dotest directory does not exist"
55         unmerged=$(git ls-files -u)
56         if test -n "$unmerged"
57         then
58                 echo "You still have unmerged paths in your index"
59                 echo "did you forget to use git add?"
60                 die "$RESOLVEMSG"
61         fi
63         cmt=`cat "$dotest/current"`
64         if ! git diff-index --quiet HEAD --
65         then
66                 if ! git commit --no-verify -C "$cmt"
67                 then
68                         echo "Commit failed, please do not call \"git commit\""
69                         echo "directly, but instead do one of the following: "
70                         die "$RESOLVEMSG"
71                 fi
72                 printf "Committed: %0${prec}d " $msgnum
73         else
74                 printf "Already applied: %0${prec}d " $msgnum
75         fi
76         git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
78         prev_head=`git rev-parse HEAD^0`
79         # save the resulting commit so we can read-tree on it later
80         echo "$prev_head" > "$dotest/prev_head"
82         # onto the next patch:
83         msgnum=$(($msgnum + 1))
84         echo "$msgnum" >"$dotest/msgnum"
85 }
87 call_merge () {
88         cmt="$(cat "$dotest/cmt.$1")"
89         echo "$cmt" > "$dotest/current"
90         hd=$(git rev-parse --verify HEAD)
91         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
92         msgnum=$(cat "$dotest/msgnum")
93         end=$(cat "$dotest/end")
94         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
95         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
96         export GITHEAD_$cmt GITHEAD_$hd
97         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
98         rv=$?
99         case "$rv" in
100         0)
101                 unset GITHEAD_$cmt GITHEAD_$hd
102                 return
103                 ;;
104         1)
105                 git rerere
106                 die "$RESOLVEMSG"
107                 ;;
108         2)
109                 echo "Strategy: $rv $strategy failed, try another" 1>&2
110                 die "$RESOLVEMSG"
111                 ;;
112         *)
113                 die "Unknown exit code ($rv) from command:" \
114                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
115                 ;;
116         esac
119 move_to_original_branch () {
120         test -z "$head_name" &&
121                 head_name="$(cat "$dotest"/head-name)" &&
122                 onto="$(cat "$dotest"/onto)" &&
123                 orig_head="$(cat "$dotest"/orig-head)"
124         case "$head_name" in
125         refs/*)
126                 message="rebase finished: $head_name onto $onto"
127                 git update-ref -m "$message" \
128                         $head_name $(git rev-parse HEAD) $orig_head &&
129                 git symbolic-ref HEAD $head_name ||
130                 die "Could not move back to $head_name"
131                 ;;
132         esac
135 finish_rb_merge () {
136         move_to_original_branch
137         rm -r "$dotest"
138         echo "All done."
141 is_interactive () {
142         test -f "$dotest"/interactive ||
143         while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
144                 shift
145         done && test -n "$1"
148 is_interactive "$@" && exec git-rebase--interactive "$@"
150 while test $# != 0
151 do
152         case "$1" in
153         --continue)
154                 git diff-files --quiet || {
155                         echo "You must edit all merge conflicts and then"
156                         echo "mark them as resolved using git add"
157                         exit 1
158                 }
159                 if test -d "$dotest"
160                 then
161                         prev_head=$(cat "$dotest/prev_head")
162                         end=$(cat "$dotest/end")
163                         msgnum=$(cat "$dotest/msgnum")
164                         onto=$(cat "$dotest/onto")
165                         continue_merge
166                         while test "$msgnum" -le "$end"
167                         do
168                                 call_merge "$msgnum"
169                                 continue_merge
170                         done
171                         finish_rb_merge
172                         exit
173                 fi
174                 head_name=$(cat .dotest/head-name) &&
175                 onto=$(cat .dotest/onto) &&
176                 orig_head=$(cat .dotest/orig-head) &&
177                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
178                 move_to_original_branch
179                 exit
180                 ;;
181         --skip)
182                 git reset --hard HEAD || exit $?
183                 if test -d "$dotest"
184                 then
185                         git rerere clear
186                         prev_head=$(cat "$dotest/prev_head")
187                         end=$(cat "$dotest/end")
188                         msgnum=$(cat "$dotest/msgnum")
189                         msgnum=$(($msgnum + 1))
190                         onto=$(cat "$dotest/onto")
191                         while test "$msgnum" -le "$end"
192                         do
193                                 call_merge "$msgnum"
194                                 continue_merge
195                         done
196                         finish_rb_merge
197                         exit
198                 fi
199                 head_name=$(cat .dotest/head-name) &&
200                 onto=$(cat .dotest/onto) &&
201                 orig_head=$(cat .dotest/orig-head) &&
202                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
203                 move_to_original_branch
204                 exit
205                 ;;
206         --abort)
207                 git rerere clear
208                 if test -d "$dotest"
209                 then
210                         move_to_original_branch
211                 elif test -d .dotest
212                 then
213                         dotest=.dotest
214                         move_to_original_branch
215                 else
216                         die "No rebase in progress?"
217                 fi
218                 git reset --hard $(cat $dotest/orig-head)
219                 rm -r "$dotest"
220                 exit
221                 ;;
222         --onto)
223                 test 2 -le "$#" || usage
224                 newbase="$2"
225                 shift
226                 ;;
227         -M|-m|--m|--me|--mer|--merg|--merge)
228                 do_merge=t
229                 ;;
230         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
231                 --strateg=*|--strategy=*|\
232         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
233                 case "$#,$1" in
234                 *,*=*)
235                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
236                 1,*)
237                         usage ;;
238                 *)
239                         strategy="$2"
240                         shift ;;
241                 esac
242                 do_merge=t
243                 ;;
244         -v|--verbose)
245                 verbose=t
246                 ;;
247         --whitespace=*)
248                 git_am_opt="$git_am_opt $1"
249                 ;;
250         -C*)
251                 git_am_opt="$git_am_opt $1"
252                 ;;
253         -*)
254                 usage
255                 ;;
256         *)
257                 break
258                 ;;
259         esac
260         shift
261 done
263 # Make sure we do not have .dotest
264 if test -z "$do_merge"
265 then
266         if mkdir .dotest
267         then
268                 rmdir .dotest
269         else
270                 echo >&2 '
271 It seems that I cannot create a .dotest directory, and I wonder if you
272 are in the middle of patch application or another rebase.  If that is not
273 the case, please rm -fr .dotest and run me again.  I am stopping in case
274 you still have something valuable there.'
275                 exit 1
276         fi
277 else
278         if test -d "$dotest"
279         then
280                 die "previous dotest directory $dotest still exists." \
281                         'try git-rebase < --continue | --abort >'
282         fi
283 fi
285 # The tree must be really really clean.
286 git update-index --refresh || exit
287 diff=$(git diff-index --cached --name-status -r HEAD --)
288 case "$diff" in
289 ?*)     echo "cannot rebase: your index is not up-to-date"
290         echo "$diff"
291         exit 1
292         ;;
293 esac
295 # The upstream head must be given.  Make sure it is valid.
296 upstream_name="$1"
297 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
298     die "invalid upstream $upstream_name"
300 # Make sure the branch to rebase onto is valid.
301 onto_name=${newbase-"$upstream_name"}
302 onto=$(git rev-parse --verify "${onto_name}^0") || exit
304 # If a hook exists, give it a chance to interrupt
305 if test -x "$GIT_DIR/hooks/pre-rebase"
306 then
307         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
308                 echo >&2 "The pre-rebase hook refused to rebase."
309                 exit 1
310         }
311 fi
313 # If the branch to rebase is given, first switch to it.
314 case "$#" in
315 2)
316         branch_name="$2"
317         git-checkout "$2" || usage
318         ;;
319 *)
320         if branch_name=`git symbolic-ref -q HEAD`
321         then
322                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
323         else
324                 branch_name=HEAD ;# detached
325         fi
326         ;;
327 esac
328 branch=$(git rev-parse --verify "${branch_name}^0") || exit
330 # Now we are rebasing commits $upstream..$branch on top of $onto
332 # Check if we are already based on $onto with linear history,
333 # but this should be done only when upstream and onto are the same.
334 mb=$(git merge-base "$onto" "$branch")
335 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
336         # linear history?
337         ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
338 then
339         echo >&2 "Current branch $branch_name is up to date."
340         exit 0
341 fi
343 if test -n "$verbose"
344 then
345         echo "Changes from $mb to $onto:"
346         # We want color (if set), but no pager
347         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
348 fi
350 # move to a detached HEAD
351 orig_head=$(git rev-parse HEAD^0)
352 head_name=$(git symbolic-ref HEAD 2> /dev/null)
353 case "$head_name" in
354 '')
355         head_name="detached HEAD"
356         ;;
357 *)
358         git checkout "$orig_head" > /dev/null 2>&1 ||
359                 die "could not detach HEAD"
360         ;;
361 esac
363 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
364 echo "First, rewinding head to replay your work on top of it..."
365 git-reset --hard "$onto"
367 # If the $onto is a proper descendant of the tip of the branch, then
368 # we just fast forwarded.
369 if test "$mb" = "$branch"
370 then
371         echo >&2 "Fast-forwarded $branch_name to $onto_name."
372         move_to_original_branch
373         exit 0
374 fi
376 if test -z "$do_merge"
377 then
378         git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
379         git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG" &&
380         move_to_original_branch
381         ret=$?
382         test 0 != $ret -a -d .dotest &&
383                 echo $head_name > .dotest/head-name &&
384                 echo $onto > .dotest/onto &&
385                 echo $orig_head > .dotest/orig-head
386         exit $ret
387 fi
389 # start doing a rebase with git-merge
390 # this is rename-aware if the recursive (default) strategy is used
392 mkdir -p "$dotest"
393 echo "$onto" > "$dotest/onto"
394 echo "$onto_name" > "$dotest/onto_name"
395 prev_head=$orig_head
396 echo "$prev_head" > "$dotest/prev_head"
397 echo "$orig_head" > "$dotest/orig-head"
398 echo "$head_name" > "$dotest/head-name"
400 msgnum=0
401 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
402 do
403         msgnum=$(($msgnum + 1))
404         echo "$cmt" > "$dotest/cmt.$msgnum"
405 done
407 echo 1 >"$dotest/msgnum"
408 echo $msgnum >"$dotest/end"
410 end=$msgnum
411 msgnum=1
413 while test "$msgnum" -le "$end"
414 do
415         call_merge "$msgnum"
416         continue_merge
417 done
419 finish_rb_merge